
      function liquid(x)
      implicit none
      include 'local.h'
      real*8 h,hl,pi,cte,ctel
      real*8 x,liquid

c      liquid= x
c      liquid = ctel*erf(x/hl)
c      liquid = erf(x/hl)
c	liquid=-1+2*hl*tanh(x/hl)/cte
	liquid=2*hl*tanh(x/hl)/cte
      return
      end

      function liquid1(x)
      implicit none
      include 'local.h'
      real*8 h,hl,pi,cte,ctel
      real*8 x,liquid1

c      liquid1= 1.0d0
c      liquid1 =  ctel*2*exp(-x**2/hl**2)/(pi**(0.5)*hl)
c      liquid1 =  2*exp(-x**2/hl**2)/(pi**(0.5)*hl)
 	liquid1=  2/(cte*(cosh(x/hl))**2) 
      return
      end

      function liquid2(x)
      implicit none
      include 'local.h'
      real*8 h,hl,pi,cte,ctel
      real*8 x,liquid2

c      liquid2= 0.
c      liquid2 = -4.* ctel*x*exp(-x**2/hl**2)/(pi**(0.5)*hl**3)
c      liquid2 = -4.*x*exp(-x**2/hl**2)/(pi**(0.5)*hl**3)
	liquid2=-4*tanh(x/hl)/(cte*hl*(cosh(x/hl))**2)
      return 
      end




      function gaz(x)
      implicit none
      include 'local.h'
      real*8 x,gaz,h,hl,pi,cte,ctel
c           gaz= cte*erf(x/h)
	if(x<h) then
c		gaz=(2*x-h)/h
		gaz=(2*x)/h
	else
c		gaz=1
		gaz=2.d0
	endif		
      return 
      end

      function gaz1(x)
      implicit none
      include 'local.h'
      real*8 x,gaz1,h,hl,pi,cte,ctel
c            gaz1= cte*2*exp(-x**2/h**2)/(pi**(0.5)*h)
		gaz1=2.d0/h
      return
      end

      function gaz2(x)
      implicit none
      include 'local.h'
      real*8 x,gaz2,h,hl,pi,cte,ctel
c        gaz2= -4.*cte*x*exp(-x**2/h**2)/(pi**(0.5)*h**3)
	gaz2=0.d0
      return 
      end

      


      function boundary(ordre,n,x)
      integer n,ordre
      real*8 x,boundary

      if (ordre.eq.0) then
         boundary=(x)**n
         return
      endif

      if (ordre.eq.1) then
         boundary=x**(n+1)*n**2
         return
      endif

      if (ordre.eq.2) then
         boundary=x**(n+2)*n**2*(n**2-1)/3
         return
      endif

      if (ordre.eq.3) then
         boundary=x**(n+3)*n**2*(n**2-1)*(n**2-4)/15
         return
      endif
     
      return
      end
      

      subroutine write_profil(M1,M2,hmax,hmin)
      implicit none
      real*8 y,pi,liquid,liquid1,gaz,gaz1,z,hmax,hmin
     .  ,liquid2,gaz2,hy
      integer M1,M2,k,nliq,ngas,ny
      pi= 2.0d0*asin(1.0d0)

c  also make a simpler output file with N equally spaced points for
c  initializing a surfer run
     

      open(unit=1,file='profil')
         do k=M1-1,1,-1
             z=cos(pi*k/M1)
             y=(z-1.)*(hmin/2.)
             write(1,*) y,liquid(y),liquid1(y),liquid2(y)
         enddo
         do k=1,M2-1
             z=cos(pi*k/M2)
             y=(1.-z)*(hmax/2.)
             write(1,*)y,gaz(y),gaz1(y),gaz2(y)
         enddo
      close(1)




      open(unit=2,file='ini.profil')

        ny = 514

c        ny = 258

      hy= (hmin + hmax)/(ny-2)

      nliq = int(0.5+ (hmin/hy))
      ngas = ny-2-nliq
      do k= 1,nliq
         y = -hmin + (k - 0.5)*hy
         write(2,*) y,liquid(y),1.0,liquid1(y)
      enddo
      do k= 1,ngas
         y = (k - 0.5)*hy
         write(2,*) y,gaz(y),0.0,gaz1(y)
      enddo

   12 format(1p,4e18.9)
      return
      end
           





      subroutine write_eigenfun(mode,M1,M2,N,hmax,hmin
     .                         ,vr,vrd,vi,vid,fno,iw)

      implicit none
      integer M1,M2,k,N,i,fno,mode,vrd,vid,efine,iw
      real*8 y,pi,z,hmax,hmin,vr(vrd,N),vi(vid,N),auxr,auxi

c  output only every efine points
      efine = 2
      pi= 2.0d0*asin(1.0d0)

      if(iw.eq.0) return

c  do the liquid
      do k=M1-1,1,-efine
        z=cos(pi*k/M1)
        y=(z-1.)*(hmin/2.)
        auxr = 0.0d0
        auxi = 0.0d0
        do i=1,M1+3
          auxr=auxr+vr(i,mode)*cos(i*acos(z))
          auxi=auxi+vi(i,mode)*cos(i*acos(z))
        enddo
        write(fno,*) y,auxr,auxi
       enddo
c  now do the gas
      do k=1,M2-1,efine
        z=cos(pi*k/M2)
        y=(1.-z)*(hmax/2.)
        auxr = 0.0d0
        auxi = 0.0d0
        do i=1,M2+3
          auxr=auxr+vr(i+M1+3,mode)*cos(i*acos(z))
          auxi=auxi+vi(i+M1+3,mode)*cos(i*acos(z))
        enddo
        write(fno,*) y,auxr,auxi
      enddo

      return
      end
           


      subroutine write_efsurfer(mode,M1,M2,N,hmax,hmin
     .                     ,vr,vrd,vi,vid,fno,iw)
      implicit none

      integer M1,M2,k,N,i,fno,mode,vrd,vid,efine
     .   ,nliq,ngas,ny,iw

      real*8 y,pi,z,hmax,hmin,vr(vrd,N),vi(vid,N),auxr,auxi
     .   ,hy,auxyr,auxyi,auxyyr,auxyyi,tche,tche1,tche2

      external tche,tche1,tche2


c Always write the surfer initial condition eigenfunction !
c      if (iw.eq.0) return

      pi= 2.0d0*asin(1.0d0)
c      ny = 130
      ny = 514
      hy= (hmin + hmax)/(ny-2)
      nliq = int(0.5+ (hmin/hy))
      ngas = ny-2-nliq

c  do the liquid

      do k= 1,nliq
         y = -hmin + (k - 0.5)*hy
c         y=(z-1.)*(hmin/2.)
         z=2.*y/hmin + 1.0
         auxr = 0.0d0
         auxi = 0.0d0
         auxyr = 0.0d0
         auxyi = 0.0d0
         auxyyr = 0.0d0
         auxyyi = 0.0d0
         do i=1,M1+3
          auxr=auxr+vr(i,mode)*tche(i,z)
          auxi=auxi+vi(i,mode)*tche(i,z)
          auxyr=auxyr+vr(i,mode)*tche1(i,z) *(2./hmin)
          auxyi=auxyi+vi(i,mode)*tche1(i,z) *(2./hmin)
          auxyyr=auxyyr+vr(i,mode)*tche2(i,z)*(2./hmin)**2.
          auxyyi=auxyyi+vi(i,mode)*tche2(i,z)*(2./hmin)**2.
         enddo
c                        y phi_R phi_R' phi_I phi_I' phi_R'' phi_I''
         write(fno,3434) y,auxr, auxyr, auxi, auxyi, auxyyr, auxyyi
      enddo

      do k= 1,ngas
         y = (k - 0.5)*hy
         z = 1.0 - (2.0*y/hmax)
         auxr = 0.0d0
         auxi = 0.0d0
         auxyr = 0.0d0
         auxyi = 0.0d0
         auxyyr = 0.0d0
         auxyyi = 0.0d0
         do i=1,M2+3
          auxr=auxr+vr(i+M1+3,mode)*tche(i,z)
          auxi=auxi+vi(i+M1+3,mode)*tche(i,z)
          auxyr=auxyr+vr(i+M1+3,mode)*tche1(i,z) *(-2.0/hmax)
          auxyi=auxyi+vi(i+M1+3,mode)*tche1(i,z) *(-2.0/hmax)
          auxyyr=auxyyr+vr(i+M1+3,mode)*tche2(i,z) *(-2.0/hmax)**2.
          auxyyi=auxyyi+vi(i+M1+3,mode)*tche2(i,z) *(-2.0/hmax)**2.
         enddo
c                        y phi_R phi_R' phi_I phi_I' phi_R'' phi_I''
         write(fno,3434) y,auxr, auxyr, auxi, auxyi, auxyyr, auxyyi
      enddo

 3434 format (7e18.9)
      return
      end
           





      subroutine sort(n,mr,dx)
c partition-exchange sorting,by hoare (comp. j. 5(1962),10-15)
c = alogorithm q in "the art of computer programming" vol. 3,by knuth
c for real data.

      real*8 dx,dxx,dzz
      parameter(m=9)
      integer*4 maxstk,msp
      parameter(maxstk=1000)
      dimension dx(*),mr(*)
      real*8 dkmax,dkmin
      integer*4 mstackl(maxstk),mstackr(maxstk)
      integer*4 mdeltrj,mdeltjl
c modif  (dkmin=min(dx(*)),dkmax=max(dx(*)))
      dkmax=dx(n)
      dkmin=dkmax
      do 1111 i=n,1,-1
      dx(i+1)=dx(i)
      dkmax=max(dkmax,dx(i+1))
      dkmin=min(dkmin,dx(i+1))
      mr(i+1)=mr(i)
 1111 continue
      dx(1)=dkmin-1
      dx(n+2)=dkmax+1
c end modif
cq1
      if(n.le.m)goto 9
c..stack empty
      msp=0
      mleft=1
      mright=n
cq2
  2   j=mright+1
      dxx=dx(mleft+1)
      mrr=mr(mleft+1)
      i=mleft
cq3
  3   i=i+1
      if(dx(i+1).lt.dxx)goto 3
cq4
  4   j=j-1
      if(dxx.lt.dx(j+1))goto 4
cq5
      if(j.le.i)then
      mr(mleft+1)=mr(j+1)
      mr(j+1)=mrr
      dx(mleft+1)=dx(j+1)
      dx(j+1)=dxx
      goto 7
      endif
cq6
      mz=mr(i+1)
      mr(i+1)=mr(j+1)
      mr(j+1)=mz
      dzz=dx(i+1)
      dx(i+1)=dx(j+1)
      dx(j+1)=dzz
      goto 3
cq7
  7    continue
       mdeltrj=mright-j-m
       mdeltjl=j-mleft-m
       if(mdeltrj.ge.mdeltjl)goto 71
       if(mdeltjl.le.0)goto 8
       if(mdeltrj.le.0)goto 73
       msp=msp+1
       if(msp.gt.maxstk)then
       print *,'stack full'
       stop
       endif
       mstackl(msp)=mleft
       mstackr(msp)=j-1
 74    mleft=j+1
       goto 2
 71    if(mdeltrj.le.0)goto 8
       if(mdeltjl.le.0)goto 74
       msp=msp+1
       if(msp.gt.maxstk)then
       print *,'stack full'
       stop
       endif
       mstackl(msp)=j+1
       mstackr(msp)=mright
 73    mright=j-1
       goto 2
cq8
  8   if(msp.ge.1)then
       mleft=mstackl(msp)
       mright=mstackr(msp)
       msp=msp-1
       goto 2
      endif
cq9
 9    do 19 j=2,n
       if(dx(j).gt.dx(j+1))then
       dxx=dx(j+1)
       mrr=mr(j+1)
       i=j-1
 29      i=i-1
       mr(i+3)=mr(i+2)
       dx(i+3)=dx(i+2)
       if(dx(i+1).gt.dxx)goto 29
       mr(i+2)=mrr
       dx(i+2)=dxx
       endif
 19    continue
       do 1112 i=1,n
       dx(i)=dx(i+1)
       mr(i)=mr(i+1)
 1112  continue
       return
       end


